#include <afx.h>
#include <afxdb.h>
#include <winnt.h>
#include <winbase.h>


class myRS : public CRecordset
{
public:
    DECLARE_DYNAMIC(myRS);

    myRS(CDatabase* pdb = NULL)
        : CRecordset(pdb)
    {
        m_ID = 0;
        m_c2_s = _T("");

        m_nFields = 2;                     // should be last field. Must be updated if new fields added
    }
    virtual void DoFieldExchange(CFieldExchange* pFX)
    {
        pFX->SetFieldType(CFieldExchange::outputColumn);
        RFX_Long(pFX, _T("[ID]"), m_ID);
        RFX_Text(pFX, _T("[c2_s]"), m_c2_s);
    }
    virtual CString GetDefaultConnect()
    {
        return "ODBC;DSN=test1";
    }
    virtual CString GetDefaultSQL()
    {
        return _T("SELECT `ID`,`c2_s` FROM tab1");
    }

    long    m_ID;
    CString m_c2_s;
};
IMPLEMENT_DYNAMIC(myRS, CRecordset);

//----------------------------------------------------------------
int main(int argc, char ** argv)
{
// odbc mysql driver 3.51.23,
// Server version: 5.0.45-community-nt MySQL Community Edition (GPL)
//
// Issue:
//    delay of exactly 60 seconds during update 
//      - cursor1 - table tab1 is openend 1st as forward only (db connect 1)
//      - cursor2 - table tab2 is opened in snapshot mode (db connect 2) (need to update), result set size = 1 (select .... where id=XXX)
//      - cursor2 update takes exactly 60 seconds
//    I have tested same scenario on different databases with different record sizes
//    100,000 and 700,000 and the delay is always 60 seconds,
//    There appear to be some lock inteference between cursor1 and cursor2
//    CPU and dysk I/O of mysql server is idle during that 60 seconds.
//    
//    I am expecting update on cursor2 be fast as the cursor contains one record only.
// 
// Steps to reproduce
//    - create test1 DSN (see odbc-opts-test1.reg.txt)
//    - load table with 100,000 records (see create-table.sql load-recs-100k.sql)
//    - run test program

    LPCSTR             locus = "";
    try{
        CDatabase  * db = NULL, * db2 = NULL;
        if(1){
            db = new CDatabase; 
            db->OpenEx("DSN=test1", CDatabase::noOdbcDialog); printf("opendb\n");

            db2 = new CDatabase; 
            db2->OpenEx("DSN=test1", CDatabase::noOdbcDialog); printf("opendb\n");
        }
        myRS  *  t1 = new myRS(db);
        myRS  *  t2 = new myRS(db2);

        int id = 1;

//        t2->m_strFilter.Format("id = %d", id);
        t2->Open(CRecordset::forwardOnly); printf("t2.open forward\n");

        t1->m_strFilter.Format("id = %d", id);
        t1->Open(); printf("t1.open\n");
        if(t1->IsEOF()) { printf("ERROR Noting to udpate\n"); return 1; } t1->Edit(); printf("Edit\n");

        srand(time(NULL));
        t1->m_c2_s.Format("%d", long(rand()));

        printf("before-update\n"); time_t start=time(NULL);
        t1->Update();
        printf("after-update dur=%d\n", time(NULL)-start);

        printf("before-close\n");
        t1->Close();
        delete db;
        printf("OK\n");
    }catch(CException  * ee){
        char      buff[256];
        ee->GetErrorMessage(buff, sizeof buff);
        printf("ERROR %s - %s\n", locus, buff);
        ee->Delete();
        return 1;
    }

    return 0;
}
